XnModuleGeneratorInterface Struct Reference

`#include <XnModuleInterface.h>`

## Public Attributes

XnModuleProductionNodeInterface * | pProductionNodeInterface
XnStatus(* | StartGenerating )(XnModuleNodeHandle hGenerator)
XnBool(* | IsGenerating )(XnModuleNodeHandle hGenerator)
void(* | StopGenerating )(XnModuleNodeHandle hGenerator)
XnStatus(* | RegisterToGenerationRunningChange )(XnModuleNodeHandle hGenerator, XnModuleStateChangedHandler handler, void *pCookie, XnCallbackHandle *phCallback)
void(* | UnregisterFromGenerationRunningChange )(XnModuleNodeHandle hGenerator, XnCallbackHandle hCallback)
XnStatus(* | RegisterToNewDataAvailable )(XnModuleNodeHandle hGenerator, XnModuleStateChangedHandler handler, void *pCookie, XnCallbackHandle *phCallback)
void(* | UnregisterFromNewDataAvailable )(XnModuleNodeHandle hGenerator, XnCallbackHandle hCallback)
XnBool(* | IsNewDataAvailable )(XnModuleNodeHandle hGenerator, XnUInt64 *pnTimestamp)
XnStatus(* | UpdateData )(XnModuleNodeHandle hGenerator)
XnUInt32(* | GetDataSize )(XnModuleNodeHandle hGenerator)
XnUInt64(* | GetTimestamp )(XnModuleNodeHandle hGenerator)
XnUInt32(* | GetFrameID )(XnModuleNodeHandle hGenerator)
XnModuleMirrorInterface * | pMirrorInterface
XnModuleAlternativeViewPointInterface * | pAlternativeViewPointInterface
void * | pObsolete1
XnModuleFrameSyncInterface * | pFrameSyncInterface
const void *(* | GetData )(XnModuleNodeHandle hGenerator)

## Detailed Description

The interface of a generator.

## Member Data Documentation

## GetData

const void *(* XnModuleGeneratorInterface::GetData) (XnModuleNodeHandle hGenerator)

Gets pointer to current data.

Parameters

  hGenerator | [in] A handle to the instance.

## GetDataSize

XnUInt32(* XnModuleGeneratorInterface::GetDataSize) (XnModuleNodeHandle hGenerator)

Gets the size of current data, in bytes.

Parameters

  hGenerator | [in] A handle to the instance.

## GetFrameID

XnUInt32(* XnModuleGeneratorInterface::GetFrameID) (XnModuleNodeHandle hGenerator)

Gets the frame ID of current data.

Parameters

  hGenerator | [in] A handle to the instance.

## GetTimestamp

XnUInt64(* XnModuleGeneratorInterface::GetTimestamp) (XnModuleNodeHandle hGenerator)

Gets the timestamp of current data, in microseconds.

Parameters

  hGenerator | [in] A handle to the instance.

## IsGenerating

XnBool(* XnModuleGeneratorInterface::IsGenerating) (XnModuleNodeHandle hGenerator)

Checks if the generator is currently generating.

Parameters

  hGenerator | [in] A handle to the instance.

## IsNewDataAvailable

XnBool(* XnModuleGeneratorInterface::IsNewDataAvailable) (XnModuleNodeHandle hGenerator, XnUInt64 *pnTimestamp)

Checks whether this node has new data (and so a call to xn::Generator::WaitAndUpdateData() will not block).

Parameters

  hGenerator | [in] A handle to the instance to be updated.
  pnTimestamp | [out] If new data is available, the timestamp of that data.

## pAlternativeViewPointInterface

XnModuleAlternativeViewPointInterface* XnModuleGeneratorInterface::pAlternativeViewPointInterface

## pFrameSyncInterface

XnModuleFrameSyncInterface* XnModuleGeneratorInterface::pFrameSyncInterface

## pMirrorInterface

XnModuleMirrorInterface* XnModuleGeneratorInterface::pMirrorInterface

## pObsolete1

void* XnModuleGeneratorInterface::pObsolete1

## pProductionNodeInterface

XnModuleProductionNodeInterface* XnModuleGeneratorInterface::pProductionNodeInterface

Contains production node interface.

## RegisterToGenerationRunningChange

XnStatus(* XnModuleGeneratorInterface::RegisterToGenerationRunningChange) (XnModuleNodeHandle hGenerator, XnModuleStateChangedHandler handler, void *pCookie, XnCallbackHandle *phCallback)

Registers a callback function to be called when generation starts or stops.

Parameters

  hGenerator | [in] A handle to the instance.
  handler | [in] A pointer to a function that will be called when generation starts/stops.
  pCookie | [in] A user cookie that will be passed to the callback function.
  phCallback | [out] Optional. Will be filled with a handle to be passed to UnregisterFromGenerationRunningChange().

## RegisterToNewDataAvailable

XnStatus(* XnModuleGeneratorInterface::RegisterToNewDataAvailable) (XnModuleNodeHandle hGenerator, XnModuleStateChangedHandler handler, void *pCookie, XnCallbackHandle *phCallback)

Registers a callback function to be called when new data is available.

Parameters

  handler | [in] A pointer to a function that will be called when new data is available.
  pCookie | [in] A user cookie that will be passed to the callback function.
  phCallback | [out] Optional. Will be filled with a handle to be passed to UnregisterFromNewDataAvailable().

## StartGenerating

XnStatus(* XnModuleGeneratorInterface::StartGenerating) (XnModuleNodeHandle hGenerator)

Starts generation of the output.

Parameters

  hGenerator | [in] A handle to the instance to start generating.

## StopGenerating

void(* XnModuleGeneratorInterface::StopGenerating) (XnModuleNodeHandle hGenerator)

Stops generation of the output.

Parameters

  hGenerator | [in] A handle to the instance to stop generating.

## UnregisterFromGenerationRunningChange

void(* XnModuleGeneratorInterface::UnregisterFromGenerationRunningChange) (XnModuleNodeHandle hGenerator, XnCallbackHandle hCallback)

Unregisters a callback function which was registered using RegisterToGenerationRunningChange().

Parameters

  hGenerator | [in] A handle to the instance.
  hCallback | [in] The handle to the callback returned from RegisterToGenerationRunningChange().

## UnregisterFromNewDataAvailable

void(* XnModuleGeneratorInterface::UnregisterFromNewDataAvailable) (XnModuleNodeHandle hGenerator, XnCallbackHandle hCallback)

Unregisters a callback function which was registered using RegisterToNewDataAvailable().

Parameters

  hGenerator | [in] A handle to the instance.
  hCallback | [in] The handle to the callback returned from RegisterToNewDataAvailable().

## UpdateData

XnStatus(* XnModuleGeneratorInterface::UpdateData) (XnModuleNodeHandle hGenerator)

Updates the data to the latest available one. This function will only be called AFTER the node notified OpenNI it has new data available.

Parameters

  hGenerator | [in] A handle to the instance to be updated.

The documentation for this struct was generated from the following file:

- XnModuleInterface.h